using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using CanAerospaceCore;
using FTD2XX_NET;
using System.Threading;

namespace WindowsFormsApplication2.M60
{
    public partial class M60Form : Form
    {
        public M60Form()
        {
            InitializeComponent();
        }

        private void M60Form_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.M60_FormLocation = Location;
            Properties.Settings.Default.Save();
        }

        private void M60Form_Load(object sender, EventArgs e)
        {
            StartPosition = FormStartPosition.Manual;
            Location = Properties.Settings.Default.M60_FormLocation;
        }
       
        private void M60_refresh_Click(object sender, EventArgs e)
        {
            Form1 mainform = Application.OpenForms.OfType<Form1>().First();
            mainform.ActiveForm2 = null;
            this.Close();
        }

        private void M60_button_click(object sender, EventArgs e)
        {
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    Button button = sender as Button;
                    uint weaponChannel = 100;
                    byte weaponNodeId = 138;
                    CanData dataToWrite = new CanData();
                    //Thread.Sleep(1000);
                    byte register = 10;
                    switch (button.Name)
                    {
                        case ("M60_shot"):
                            dataToWrite.SetAsUchar((byte)(16));
                            break;
                        case ("M60_release"):
                            dataToWrite.SetAsUchar((byte)(17));
                            break;
                        default:
                            return;
                        //break;
                    }
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite);
                }

            }

        }

        public void M60_numericUpDown_ValueChanged(object sender, EventArgs e)
        {
            NumericUpDown editbox = sender as NumericUpDown;
            uint weaponChannel = 100;
            byte weaponNodeId = 138;
            CanData dataToWrite = new CanData();
            //Thread.Sleep(1000);

            byte register = 0;
            switch (editbox.Name)
            {
                case ("M60_treshlow"):
                    register = 29;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("M60_treshhigh"):
                    register = 30;
                    dataToWrite.SetAsUchar((byte)(editbox.Value));
                    break;
                case ("M60_hs3release"):
                    register = 33;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_hs3hold"):
                    register = 34;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_tempdown"):
                    register = 60;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_tempup"):
                    register = 61;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_maxledpwm"):
                    register = 62;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_downstep1"):
                    register = 63;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_downstep2"):
                    register = 64;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_downstep3"):
                    register = 65;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_upstep1"):
                    register = 66;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_upstep2"):
                    register = 67;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                case ("M60_upstep3"):
                    register = 68;
                    dataToWrite.SetAsShort((short)(editbox.Value));
                    break;
                default:
                    return;
                //break;
            }
            if (register == 0) return;
            if (Application.OpenForms.OfType<Form1>().Any())
            {
                Form1 mainform = Application.OpenForms.OfType<Form1>().First();
                if (mainform.ActiveForm2 != null)
                {
                    RegisterKey regKey = new RegisterKey(weaponNodeId, register);
                    if (mainform.canConnection.SendRegisterWriteRequest(weaponChannel, regKey, dataToWrite)) MessageBox.Show("Value changed");
                }

            }

        }


    }
}
